# DyScript Compiler

DyScript Compiler is a compiler for [DyScript](https://github.com/JustCodiex/DyScript), a simple, statically-typed scripting language. The compiler is written in F# and compiles DyScript source code to DyScript Bytecode, which can be executed by the DyScript Virtual Machine (VM) on .NET.

---

## Features

- **Statically-typed scripting language** with modern syntax.
- **Compiles to efficient bytecode** for execution on the DyScript VM.
- **Seamless .NET interop** via the DyScript runtime.
- **Modular architecture**: easily extendable with new language features and modules.
- **Rich standard library** (via core and math modules).
- **Unit tested**: robust and reliable compilation pipeline.

---

## Project Structure

- **DyScriptCompiler/**  
  The F# compiler for DyScript. Converts `.dy` source files to DyScript Bytecode.
- **DyScriptVM/**  
  The runtime and virtual machine for executing DyScript Bytecode on .NET.
- **DyScript/**  
  Example REPL and entry point for running scripts interactively.
- **DyScriptVM.Test/**  
  Unit and integration tests for the VM and language features.

---

## Getting Started

### Prerequisites

- [.NET 9 SDK](https://dotnet.microsoft.com/)
- [F# Compiler Tools](https://fsharp.org/) (for building the compiler)

### Building the Solution

Clone the repository and build the solution:
